"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const extensions_1 = require("./extensions");
const BASIC_PLUGINS = [
    'jsx',
    'asyncGenerators',
    'classProperties',
    'doExpressions',
    'exportExtensions',
    'functionBind',
    'functionSent',
    'objectRestSpread',
    'dynamicImport',
    ['decorators', { decoratorsBeforeExport: true }]
];
function pluginsForFilename(filename) {
    let isTypeScript = extensions_1.TypeScriptExtensions.has(path_1.extname(filename));
    return isTypeScript
        ? [...BASIC_PLUGINS, 'typescript']
        : [...BASIC_PLUGINS, 'flow'];
}
function default_1(babel) {
    return {
        manipulateOptions(opts, parserOpts) {
            parserOpts.sourceType = 'module';
            parserOpts.allowImportExportEverywhere = true;
            parserOpts.allowReturnOutsideFunction = true;
            parserOpts.allowSuperOutsideMethod = true;
            parserOpts.plugins = [
                ...(parserOpts.plugins || []),
                ...pluginsForFilename(opts.filename)
            ];
        }
    };
}
exports.default = default_1;
//# sourceMappingURL=AllSyntaxPlugin.js.map