/// <reference types="node" />
import * as realFs from 'fs';
import Config from './Config';
import { SourceTransformResult } from './TransformRunner';
export declare class RunResult {
    readonly stats: RunStats;
    constructor(stats: RunStats);
}
export declare class RunStats {
    readonly modified: number;
    readonly errors: number;
    readonly total: number;
    constructor(modified?: number, errors?: number, total?: number);
}
export default class CLIEngine {
    readonly config: Config;
    readonly onTransform: (result: SourceTransformResult) => void;
    readonly readStdin: () => Promise<string>;
    readonly writeStdout: (data: string) => void;
    readonly fs: typeof realFs;
    constructor(config: Config, onTransform?: (result: SourceTransformResult) => void, readStdin?: () => Promise<string>, writeStdout?: (data: string) => void, fs?: typeof realFs);
    private loadPlugins;
    run(): Promise<RunResult>;
}
