"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const resolve_1 = require("resolve");
const RecastPlugin_1 = require("./RecastPlugin");
function loadPrettier() {
    try {
        return require(resolve_1.sync('prettier', { basedir: process.cwd() }));
    }
    catch (_a) {
        return require('prettier');
    }
}
function default_1(babel) {
    let prettier = loadPrettier();
    function resolvePrettierConfig(filepath) {
        return Object.assign({}, (prettier.resolveConfig.sync(filepath) || undefined), { filepath });
    }
    return {
        parserOverride: RecastPlugin_1.parse,
        generatorOverride(ast, options, code, _generate) {
            return {
                code: prettier.format(RecastPlugin_1.generate(ast, options, code, _generate).code, resolvePrettierConfig(options.filename))
            };
        }
    };
}
exports.default = default_1;
//# sourceMappingURL=PrettierPrinterPlugin.js.map