/// <reference types="node" />
import Transformer from './Transformer';
export declare class Source {
    readonly path: string;
    readonly content: string;
    constructor(path: string, content: string);
}
export declare enum SourceTransformResultKind {
    Transformed = "Transformed",
    Error = "Error"
}
export declare type SourceTransformResult = {
    kind: SourceTransformResultKind.Transformed;
    source: Source;
    output: string;
} | {
    kind: SourceTransformResultKind.Error;
    source: Source;
    error: Error;
};
export default class TransformRunner {
    readonly sources: IterableIterator<Source> | Array<Source>;
    readonly transformer: Transformer;
    constructor(sources: IterableIterator<Source> | Array<Source>, transformer: Transformer);
    run(): AsyncIterableIterator<SourceTransformResult>;
}
